zero_length_keys.sh 3.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118
  1. #!/bin/sh
  2. # Check that tor regenerates keys when key files are zero-length
  3. # Test for bug #13111 - Tor fails to start if onion keys are zero length
  4. #
  5. # Usage:
  6. # ./zero_length_keys.sh
  7. # Run all the tests below
  8. # ./zero_length_keys.sh -z
  9. # Check tor will launch and regenerate zero-length keys
  10. # ./zero_length_keys.sh -d
  11. # Check tor regenerates deleted keys (existing behaviour)
  12. # ./zero_length_keys.sh -e
  13. # Check tor does not overwrite existing keys (existing behaviour)
  14. #
  15. # Exit Statuses:
  16. # 0: test succeeded - tor regenerated/kept the files
  17. # 1: test failed - tor did not regenerate/keep the files
  18. # 2: test failed - tor did not generate the key files on first run
  19. # 3: a command failed - the test could not be completed
  20. #
  21. if [ $# -lt 1 ]; then
  22. echo "Testing that tor correctly handles zero-length keys"
  23. "$0" -z && "$0" -d && "$0" -e
  24. exit $?
  25. fi
  26. DATA_DIR=`mktemp -d -t tor_zero_length_keys.XXXXXX`
  27. if [ -z "$DATA_DIR" ]; then
  28. echo "Failure: mktemp invocation returned empty string" >&2
  29. exit 3
  30. fi
  31. if [ ! -d "$DATA_DIR" ]; then
  32. echo "Failure: mktemp invocation result doesn't point to directory" >&2
  33. exit 3
  34. fi
  35. trap "rm -rf '$DATA_DIR'" 0
  36. # DisableNetwork means that the ORPort won't actually be opened.
  37. # 'ExitRelay 0' suppresses a warning.
  38. TOR="./src/or/tor --hush --DisableNetwork 1 --ShutdownWaitLength 0 --ORPort 12345 --ExitRelay 0"
  39. if [ -s "$DATA_DIR"/keys/secret_id_key ] && [ -s "$DATA_DIR"/keys/secret_onion_key ] &&
  40. [ -s "$DATA_DIR"/keys/secret_onion_key_ntor ]; then
  41. echo "Failure: Previous tor keys present in tor data directory" >&2
  42. exit 3
  43. else
  44. echo "Generating initial tor keys"
  45. $TOR --DataDirectory "$DATA_DIR" --list-fingerprint
  46. # tor must successfully generate non-zero-length key files
  47. if [ -s "$DATA_DIR"/keys/secret_id_key ] && [ -s "$DATA_DIR"/keys/secret_onion_key ] &&
  48. [ -s "$DATA_DIR"/keys/secret_onion_key_ntor ]; then
  49. true #echo "tor generated the initial key files"
  50. else
  51. echo "Failure: tor failed to generate the initial key files"
  52. exit 2
  53. fi
  54. fi
  55. #ls -lh "$DATA_DIR"/keys/ || exit 3
  56. # backup and keep/delete/create zero-length files for the keys
  57. FILE_DESC="keeps existing"
  58. # make a backup
  59. cp -r "$DATA_DIR"/keys "$DATA_DIR"/keys.old
  60. # delete keys for -d or -z
  61. if [ "$1" != "-e" ]; then
  62. FILE_DESC="regenerates deleted"
  63. rm "$DATA_DIR"/keys/secret_id_key || exit 3
  64. rm "$DATA_DIR"/keys/secret_onion_key || exit 3
  65. rm "$DATA_DIR"/keys/secret_onion_key_ntor || exit 3
  66. fi
  67. # create empty files for -z
  68. if [ "$1" = "-z" ]; then
  69. FILE_DESC="regenerates zero-length"
  70. touch "$DATA_DIR"/keys/secret_id_key || exit 3
  71. touch "$DATA_DIR"/keys/secret_onion_key || exit 3
  72. touch "$DATA_DIR"/keys/secret_onion_key_ntor || exit 3
  73. fi
  74. echo "Running tor again to check if it $FILE_DESC keys"
  75. $TOR --DataDirectory "$DATA_DIR" --list-fingerprint
  76. #ls -lh "$DATA_DIR"/keys/ || exit 3
  77. # tor must always have non-zero-length key files
  78. if [ -s "$DATA_DIR"/keys/secret_id_key ] && [ -s "$DATA_DIR"/keys/secret_onion_key ] &&
  79. [ -s "$DATA_DIR"/keys/secret_onion_key_ntor ]; then
  80. # check if the keys are different to the old ones
  81. diff -q -r "$DATA_DIR"/keys "$DATA_DIR"/keys.old > /dev/null
  82. SAME_KEYS=$?
  83. # if we're not testing existing keys,
  84. # the current keys should be different to the old ones
  85. if [ "$1" != "-e" ]; then
  86. if [ $SAME_KEYS -ne 0 ]; then
  87. echo "Success: test that tor $FILE_DESC key files: different keys"
  88. exit 0
  89. else
  90. echo "Failure: test that tor $FILE_DESC key files: same keys"
  91. exit 1
  92. fi
  93. else #[ "$1" == "-e" ]; then
  94. if [ $SAME_KEYS -eq 0 ]; then
  95. echo "Success: test that tor $FILE_DESC key files: same keys"
  96. exit 0
  97. else
  98. echo "Failure: test that tor $FILE_DESC key files: different keys"
  99. exit 1
  100. fi
  101. fi
  102. else
  103. echo "Failure: test that tor $FILE_DESC key files: no key files"
  104. exit 1
  105. fi